﻿Imports Infragistics.Web.UI.GridControls
Imports Infragistics.Web.UI.ListControls

Public Class DdlProvider_LoadOnDemand
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Load_Grid()
    End Sub

    Private Sub Load_Grid()
        Dim ds As New DataSet
        ds.ReadXml(Server.MapPath("dsGrid.xml"))

        WDG_ThirdParty.DataSource = ds
        WDG_ThirdParty.DataBind()

        Dim dsType As New DataSet
        dsType.ReadXml(Server.MapPath("dsType.xml"))
        DDL_Ledger_Type_Lkup_ID_DropDownProvider.EditorControl.DataSource = dsType
        DDL_Ledger_Type_Lkup_ID_DropDownProvider.EditorControl.ValueField = "ID"
        DDL_Ledger_Type_Lkup_ID_DropDownProvider.EditorControl.TextField = "DESCRIPTION"
        DDL_Ledger_Type_Lkup_ID_DropDownProvider.EditorControl.DataBind()
        DDL_Ledger_Type_Lkup_ID_DropDownProvider.EditorControl.Items.Insert(0, New DropDownItem("", ""))

        For Each dr As DataRow In dsType.Tables(0).Rows
            If Not IsDBNull(dr("ID")) Then
                If HD_LedgerType.Value = "" Then
                    HD_LedgerType.Value = dr("ID")
                Else
                    HD_LedgerType.Value = HD_LedgerType.Value & "," & dr("ID")
                End If
            End If
        Next

        ds.ReadXml(Server.MapPath("dsCompany.xml"))
        DDL_LAST_NAME_DropDownProvider.EditorControl.DataSource = ds
        DDL_LAST_NAME_DropDownProvider.EditorControl.ValueField = "ID"
        DDL_LAST_NAME_DropDownProvider.EditorControl.TextField = "LAST_NAME"
        DDL_LAST_NAME_DropDownProvider.EditorControl.DataBind()
        DDL_LAST_NAME_DropDownProvider.EditorControl.Items.Insert(0, New DropDownItem("", ""))

        WDG_ThirdParty_Multi_Column.DataSource = ds
        WDG_ThirdParty_Multi_Column.DataBind()
    End Sub

    Protected Sub DDL_LAST_NAME_DropDownProvider_LoadOnDemand(sender As Object, e As EventArgs)
        'Dim ObjData As New clsTP(StringForNull(Session("P_UserName")), StringForNull(Session("P_Password")), StringForNull(Application("ServerName")), StringForNull(Application("AppPath")))
        Dim ds As New DataSet
        If HD_LedgerType.Value <> "" Then
            ds.ReadXml(Server.MapPath("dsCompany.xml"))
            DDL_LAST_NAME_DropDownProvider.EditorControl.DataSource = ds
            DDL_LAST_NAME_DropDownProvider.EditorControl.ValueField = "ID"
            DDL_LAST_NAME_DropDownProvider.EditorControl.TextField = "LAST_NAME"
            DDL_LAST_NAME_DropDownProvider.EditorControl.DataBind()
            DDL_LAST_NAME_DropDownProvider.EditorControl.Items.Insert(0, New DropDownItem("", ""))
        End If
    End Sub

    Protected Sub DDL_LAST_NAME_DropDownProvider_ItemsRequested(sender As Object, e As DropDownItemsRequestedEventArgs)
        Dim sInput = StringForNull(e.Value)
        Dim sArr As String() = sInput.Split(New String() {"$$#$$"}, StringSplitOptions.None)
        If sArr.Length > 0 Then
            If sArr(0).ToString().ToUpper() = "INIT" Then
                HD_LedgerType.Value = sArr(1)
                HD_SearchName.Value = sArr(2)
            End If
        End If
    End Sub

    Public Shared Function StringForNull(ByVal x As Object) As String
        If IsDBNull(x) Then
            Return ""
        ElseIf x Is Nothing Then
            Return ""
        Else
            Return Trim(CStr(x))
        End If
    End Function
End Class