﻿Imports Infragistics.Web.UI.GridControls

Public Class WebDDL_LoadOnDemand
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            HD_SearchType.Value = ""
            HD_Entity_ID.Value = 46196
            HD_Entity_Name.Value = "Emilia Test Principal"
        End If
    End Sub

    Private Sub wcType_ItemsRequested(sender As Object, e As Infragistics.Web.UI.ListControls.DropDownItemsRequestedEventArgs) Handles wcType.ItemsRequested
        wcType.Items.Clear()
        'HD_SearchType.Value = StringForNull(e.Value)
    End Sub

    Private Sub wcType_PreRender(sender As Object, e As EventArgs) Handles wcType.PreRender
        Load_Data()
        If DoubleForNull(HD_Entity_ID.Value) > 0 AndAlso HD_SearchType.Value = "" Then
            wcType.SelectedItems.Clear()
            If wcType.Items.IndexOf(wcType.Items.FindItemByValue(DoubleForNull(HD_Entity_ID.Value))) <> -1 Then
                wcType.SelectedItemIndex = wcType.Items.IndexOf(wcType.Items.FindItemByValue(DoubleForNull(HD_Entity_ID.Value)))
            End If
        End If
    End Sub

    Private Sub Load_Data()
        Dim ds As New DataSet
        Dim dt As New DataTable
        Dim dr As DataRow
        Dim dv As DataView
        Dim sFilter As String = "LAST_NAME LIKE '%' + ISNULL('" & StringForNull(HD_SearchType.Value) & "', '') + '%'"

        ds.ReadXml(Server.MapPath("dsCompany.xml"))

        If HD_SearchType.Value = "" Then
            sFilter = "ID <> " & DoubleForNull(HD_Entity_ID.Value) & " AND " & sFilter
        End If

        dv = New DataView(ds.Tables(0), sFilter, "LAST_NAME", DataViewRowState.CurrentRows)
        dt = dv.ToTable()

        If DoubleForNull(HD_Entity_ID.Value) > 0 AndAlso HD_SearchType.Value = "" Then
            dr = dt.NewRow     'default selected item
            dr("ID") = HD_Entity_ID.Value
            dr("LAST_NAME") = HD_Entity_Name.Value
            dt.Rows.InsertAt(dr, 0)
        End If

        dr = dt.NewRow
        dr("ID") = "0"
        dr("LAST_NAME") = ""
        dt.Rows.InsertAt(dr, 0)

        wcType.DataSource = dt
        wcType.TextField = "LAST_NAME"
        wcType.ValueField = "ID"
        wcType.DataBind()
    End Sub

    Public Shared Function DoubleForNull(ByVal x As Object) As Double
        If IsNothing(x) Then
            Return 0
        ElseIf IsDBNull(x) Then
            Return 0
        ElseIf Not IsNumeric(x) Then
            Return 0
        Else
            Return CDbl(x)
        End If
    End Function

    Public Shared Function StringForNull(ByVal x As Object) As String
        If IsDBNull(x) Then
            Return ""
        ElseIf x Is Nothing Then
            Return ""
        Else
            Return Trim(CStr(x))
        End If
    End Function
End Class